##############################################################################
# PROGRAM : iLink Web Search Engine: Common Modules                          #
# VERSION : 1.05                                                             #
#                                                                            #
##############################################################################
#                                                                            #
#             __                     __                                      #
#      __    /\ \       __          /\ \                                     #
#     /\_\   \ \ \     /\_\     ___ \ \ \/'\                                 #
#     \/\ \   \ \ \  __\/\ \  /' _ `\\ \ , <                                 #
#      \ \ \   \ \ \L\ \\ \ \ /\ \/\ \\ \ \\`\                               #
#       \ \_\   \ \____/ \ \_\\ \_\ \_\\ \_\ \_\                             #
#        \/_/    \/___/   \/_/ \/_/\/_/ \/_/\/_/                             #
#                                                                            #     
#                                     ___      __      __      __            #
#                                   /'___`\  /'__`\  /'__`\  /'__`\          #
#                                  /\_\ /\ \/\ \/\ \/\ \/\ \/\ \/\ \         #
#                                  \/_/// /_\ \ \ \ \ \ \ \ \ \ \ \ \        #
#                                     // /_\ \ \ \_\ \ \ \_\ \ \ \_\ \       #
#                                    /\______/\ \____/\ \____/\ \____/       #
#                                    \/_____/  \/___/  \/___/  \/___/        #
#                                                                            #
##############################################################################
# All source code, images, programs, files included in this distribution     #
# Copyright (c) 1996,1997,1998,1999,2000                                     #
#                                                                            #
#           John C. Cokos, The CCS Network, Inc.  IWeb, Inc.                 #
#           All Rights Reserved.                                             #
#                                                                            #
# Use, distibution, sale, or access to this program is forbidden without     #
# permission, except were permitted by the license agreement.                #
#                                                                            #
##############################################################################
#                                                                            #
#    ------ DO NOT MODIFY ANYTHING BELOW THIS POINT !!! -------              #
#                                                                            #
#    Modification of the souce code of this program violates the             #
#    license agreement, and terminates your right to technical support.      #
#                                                                            #
##############################################################################

#START#

package IWEB;


sub SEARCH {

   my $searchbox = qq!
     <FORM ACTION="$PROG_URL" METHOD="get">
     <INPUT TYPE="hidden" NAME="action" VALUE="Search">
     $language{'search_prompt'} <INPUT TYPE="text" NAME="Terms">
     <INPUT TYPE="submit" VALUE="$language{'search_button'}">
     </FORM>
   !;
  
   return($searchbox);

}

sub ADD_URL {
     my $addcat = IWEB::urlencode($hyperseek{'Category'});
     return("$urls{'ilink_url'}?action=Add_Link&Category=$addcat");
}

sub Category_Listings {

    my ($catlistings,%results,$found,$shown,$xpg,$start,$end);

    if( $hyperseek{'Category'} ) {

       if($BUILDING) { %results = IWEB::Build_Matches(); }
       else {
         open(IDB,$hyperseek{'database'});
           while(<IDB>) { 
              chomp;
              ($ID,$Category,$ELink,$Position,$Qualifier,$Email,$Title,$URL,$Description,$Keys,$desc_image,$title_tag,$site_icon,$Name,$Address,$City,$State,$Zip,$Country,$Phone,$Fax,$startdate,$enddate,$price,$account,$xfactor,$field1,$field2,$field3,$field4,$field5,$field6,$field7,$field8,$field9,$field10)= split(/\|/,$_);

              if ( $Category  eq $hyperseek{'Category'} ) {
                 if($URL) {
                    $results{$Title} = qq! <A HREF="$URL" TARGET="$global{'ilink_target'}">$Title</A><BR>$Description<P>\n !;
                 }
                 else {
                    $results{$Title} = qq! <LI><B>$Title</B><BR>$Description<P> !;
                 }
                 $hyperseek{'found'}++;
              }
           } 
         close(IDB);
       }

       foreach $key(sort keys %results) {  
         $found++;
         next if ($input{'start'} && $found <= $input{'start'});
         next if($shown >= $global{'ilink_hits_per_page'});
         $shown++;
         $catlistings .= $results{$key}; 
       }

       $hyperseek{'shown'} = $input{'start'} + $shown;
       $hyperseek{'remaining'} = $found - $hyperseek{'shown'};
       $hyperseek{'previous'} = $input{'start'} - $global{'ilink_hits_per_page'};
       $hyperseek{'next'} = $input{'start'} + $global{'ilink_hits_per_page'};
       $hyperseek{'enccat'} = IWEB::urlencode($hyperseek{'Category'}); 
   
       $start = $input{'start'}+1;
       $end = $input{'start'} + $global{'ilink_hits_per_page'};
       $end = $hyperseek{'found'} if(! $hyperseek{'remaining'});

       $catlistings = "<B>$hyperseek{'found'} $language{'found'} ... $language{'showing'} $start - $end</B><BR><BR>$catlistings\n" if($hyperseek{'found'});
   
         $catlistings .= "<CENTER>\n";
      



         if($input{'start'}) { 
             if($global{'ilink_build'} eq "YES") { 
                $xpg = $page;
                $xpg--;
                $xpg="" if(! $xpg);
                $LINK = IWEB::Make_Alpha($hyperseek{'Category'});
                $LINK = "$global{'ILINK_VIRTUAL'}/$LINK$xpg.$global{'ILINK_EXT'}";
             }
             else { $LINK = "$PROG_URL?Category=$hyperseek{'enccat'}&start=$hyperseek{'previous'}"; }
   
             $catlistings .= qq! 
               <A HREF="$LINK">$language{'previous'}</A>
             !;
         }
      
         if($hyperseek{'remaining'}) { 
            $page++;
             if($global{'ilink_build'} eq "YES") { 
                $LINK = IWEB::Make_Alpha($hyperseek{'Category'});
                $LINK = "$global{'ILINK_VIRTUAL'}/$LINK$page.$global{'ILINK_EXT'}";
             }
             else { $LINK = "$PROG_URL?Category=$hyperseek{'enccat'}&start=$hyperseek{'next'}"; }
            $catlistings .= qq! 
              <A HREF="$LINK">$language{'next'}</A>
            !;
         }

         $catlistings .= "</CENTER>\n";

    }

    else {  $catlistings = IWEB::directory(); }





    return($catlistings);
}


sub directory {

   my($directory,$template,$catout,$CATLINK,$SUBS,$TableIndex,$i,$LastCategory,$x);
   my($j,$Number_Shown,@levels,$lcat,$ThisCategory,$LINK,$Count);

       $template = "<<CATEGORY>><<SUBS>><BR>";
       $directory = "<CENTER><TABLE BORDER=0 CELLSPACING=5 CELLPADDING=0 WIDTH=98%>\n";

	# Put Option List Together 

	$x = 0;
        $LastCategory = "";
	for $i (0 .. $#categories ) {

            $ThisCategory = $categories[$i]{'Category'};
            if ($ThisCategory ne $LastCategory) { 

                $catout = $template;
 
                $LastCategory = $ThisCategory ; 

                if($TableIndex==0) { $directory .= "<TR>\n"; }

		$directory .= "  <TD VALIGN=\"top\">\n";
 	        $CATLINK = "  <FONT FACE=\"$global{'font_face'}\" COLOR=\"$global{'text_color'}\" SIZE=$global{'font_size'}>\n";

                if($global{'ilink_build'} eq "YES") {
                   $LINK = IWEB::Make_Alpha($categories[$i]{'Category'});
                   $LINK = "$global{'ILINK_VIRTUAL'}/$LINK.$global{'ILINK_EXT'}";
                }
                else {
                   $lcat = &urlencode($categories[$i]{'Category'});
                   $LINK = "$PROG_URL?Category=$lcat";
                }

                $CATLINK .= "<B><A HREF=\"$LINK\">$categories[$i]{'Category'}</A></B></FONT>\n";
                $SUBS = "<FONT FACE=\"$global{'font_face'}\" COLOR=\"$global{'text_color'}\" SIZE=\"$global{'font_size'}\">\n";

                if ($global{'ilink_main_style'} eq "List") {
          
                   $Number_Shown=0;
                   for $j(0 .. $#categories) {

                    @levels = split(/\:/,$categories[$j]{'SubCategory'});
                    if ($categories[$j]{'Category'} eq $ThisCategory && $categories[$j]{'Teaser_Flag'}) {

                       # next if($Number_Shown >= 4);
                       $Number_Shown++;

                       if($global{'ilink_build'} eq "YES") {
                          $LINK = IWEB::Make_Alpha("$categories[$j]{'Category'}:$categories[$j]{'SubCategory'}"); 
                          $LINK = "$global{'ILINK_VIRTUAL'}/$LINK.$global{'ILINK_EXT'}";
                       }
                       else {
                          $lcat = &urlencode("$categories[$j]{'Category'}:$categories[$j]{'SubCategory'}");
                          $LINK = "$PROG_URL?Category=$lcat";
                       }

                       if ($global{'ilink_show_count'} ne "NO") { $Count = "[ $categories[$j]{'Count'} ]"; }
                       else { $Count = ""; }

                       $SUBS .= "<BR>&nbsp;&nbsp;";
                       $SUBS .= "<A HREF=\"$LINK\">$categories[$j]{'SubCategory'}</A> $Count\n";
                    }
                   }
                }

                elsif ($global{'ilink_main_style'} eq "Yahoo") {
          
                   $SUBS .= "<BR>";
                   $Number_Shown = 0;
                   for $j(0 .. $#categories) {

                    if ($categories[$j]{'Category'} eq $ThisCategory && $categories[$j]{'Teaser_Flag'}) {

                       # next if($Number_Shown >= 4);
                       $Number_Shown++;

                       if($global{'ilink_build'} eq "YES") {
                          $LINK = IWEB::Make_Alpha("$categories[$j]{'Category'}:$categories[$j]{'SubCategory'}"); 
                          $LINK = "$global{'ILINK_VIRTUAL'}/$LINK.$global{'ILINK_EXT'}";
                       }
                       else {
                          $lcat = &urlencode("$categories[$j]{'Category'}:$categories[$j]{'SubCategory'}");
                          $LINK = "$PROG_URL?Category=$lcat";
                       }

                       $SUBS .= " <A HREF=\"$LINK\">$categories[$j]{'SubCategory'}</A>, \n";
                    }
                   }
                   $SUBS .= "...";
                }

                $TableIndex++;

                ## Now, Use the template to draw it....
                $catout =~ s/(<<CATEGORY>>)/$CATLINK/g; 
                $catout =~ s/(<<SUBS>>)/$SUBS/g; 
                $directory .= $catout;
                $directory .= "</FONT>\n";
                $directory .= "</TD>\n";

                if( $TableIndex>=$global{'ilink_main_columns'} ) {
                    $directory .= "</TR>\n";
                    $TableIndex=0;
                }

		$x++;

            }

	}

        $directory .= "</TABLE></CENTER>\n";

    return($directory);

}


sub MENU {

   my(@xx, $Category, $menu, $fullcat, $golink,@xx);

   @xx=split(/\:/,$hyperseek{'Category'});

   if( $hyperseek{'Category'} ) { 

        foreach $Category(@xx) {
           if($menu) { $menu .= " : "; }
           if($fullcat) { $fullcat .= ":"; }
           $fullcat .= $Category;
           if ($global{'ilink_build'} eq "YES") {
             $golink = IWEB::Make_Alpha($fullcat);
             $menu .=  qq! <A HREF="$global{'ILINK_VIRTUAL'}/$golink.$global{'ILINK_EXT'}">$Category</A> !;
          }
          else {
             $golink=&urlencode($fullcat);
             $menu .= qq! <A HREF="$PROG_URL?Category=$golink">$Category</A> !;
          }
        }

        $menu = qq! <A HREF="$global{'ilink_toplink_target'}">$language{'home'}</A>:: $menu!;
   }

   elsif($input{'Terms'}) {
        $menu = qq! <A HREF="$global{'ilink_toplink_target'}">$language{'home'}</A>:: $language{'search_results'} [$input{'Terms'}] !;
   }

   return($menu);

}

sub CATEGORIES {

   my($catreturn,@xx,$x,$num_levels_to_show,@subs,$num_subs,$checkcat,$del);
   my($Category,$SubCat,$Count,$Current,$CNT,$golink,$showlink,@go,@show,@counts);
   my($Found,$f,$nms,$NumSubs,$fullcat,$number_per_column);

        @xx=split(/\:/,$hyperseek{'Category'});
        $num_levels_to_show = $#xx;

        $catreturn = "<TABLE BORDER=0 CELLSPACING=6 WIDTH=\"98%\"><TR>\n";
        $catreturn .= "<TD VALIGN=\"top\" ALIGN=\"left\">\n";
        $catreturn .= "<FONT FACE=\"$global{'font_face'}\" SIZE=\"$global{'font_size'}\">\n";


        for $x( 0 .. $#categories ) {

          $Category = $categories[$x]{'Category'};
          $SubCat = $categories[$x]{'SubCategory'};
          $Count = $categories[$x]{'Count'};

          next if(! $Category);
          next if($Category ne $xx[0]);

          $Current = "$Category:$SubCat";

          if($global{'ilink_show_count'} ne "NO" && $Count) { $CNT = "<FONT SIZE=-1>($Count)</FONT>"; }
          else { $CNT = ''; }

          @subs = split(/\:/,$Current);
          $num_subs = $#subs;
          next if( ($num_subs -1) != $num_levels_to_show);

          $checkcat = $Current;
          $del = quotemeta($subs[$num_subs]);
          $checkcat =~ s/\:$del//g;

          next if( $hyperseek{'Category'} ne $checkcat);

          $golink = $Current;
          $showlink = $Current;
          $showlink =~ s/$hyperseek{'Category'}\://g;

          $Found++;
          if ($global{'ilink_build'} eq "YES") {
             $golink = IWEB::Make_Alpha($golink);
             push @go, "$global{'ILINK_VIRTUAL'}/$golink.$global{'ILINK_EXT'}";
          }
          else {
             $golink=&urlencode($golink);
             push @go, "$PROG_URL?Category=$golink";
          }
          push @show, $showlink;
          push @counts, $CNT;

        }

        ## Show them all in the right number of columns ..

        $number_per_column = ($Found) / ($global{'ilink_menu_columns'});

        for $f(0 .. $#go) {
           $nms++;
           if ($NumSubs >= $number_per_column) {
               $catreturn .= "</FONT></TD><TD VALIGN=\"top\" ALIGN=\"left\">\n";
               $catreturn .= "<FONT FACE=\"$global{'font_face'}\" SIZE=\"$global{'font_size'}\">\n";
               $NumSubs=0;
           }

           $catreturn .= "<a href=\"$go[$f]\">";
           $catreturn .= "$show[$f]</a> $counts[$f]<BR>\n";
           $NumSubs++;
        }

        $catreturn .= "</FONT></TD></TR>\n";
        $catreturn .= "</TD></TR></TABLE>\n";

   return($catreturn);

}


sub Powered_By {

  my ($pb) = qq!
     <BR><BR>
     <A HREF="http://www.iwebsys.com" TARGET="_blank">
     <IMG SRC="http://www.iwebsys.com/images/iwebbutton.gif" WIDTH="88" HEIGHT="31" BORDER=0 ALT="Powered By Interactive Web CGI Applications"></A><BR>
     Powered By iWeb
     <BR><BR>
  !;

  return($pb);

}

1;
